<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content class">
                   <div class="content-data">











<ol class="breadcrumb">
  <li>Classes</li>
  <li>DomainInfluenceFileDataSource</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/app/operation/parameters/domain-influence/domain-influence-edit.component.ts</code>
        </p>


            <p class="comment">
                <h3>Extends</h3>
            </p>
            <p class="comment">
                    <code>DataSource</code>
            </p>



            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#connect">connect</a>
                            </li>
                            <li>
                                <a href="#disconnect">disconnect</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(parametersModel: <a href="../injectables/OperationParametersModel.html">OperationParametersModel</a>)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="160" class="link-to-prism">src/app/operation/parameters/domain-influence/domain-influence-edit.component.ts:160</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>parametersModel</td>
                                                  
                                                        <td>
                                                                    <code><a href="../injectables/OperationParametersModel.html" target="_self" >OperationParametersModel</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>


            <section>
    
        <h3 id="methods">
            Methods
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="connect"></a>
                        <span class="name">
                            <b>
                            connect
                            </b>
                            <a href="#connect"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>connect()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="165" class="link-to-prism">src/app/operation/parameters/domain-influence/domain-influence-edit.component.ts:165</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="../classes/DomainInfluenceFile.html" target="_self" >Observable&lt;DomainInfluenceFile[]&gt;</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="disconnect"></a>
                        <span class="name">
                            <b>
                            disconnect
                            </b>
                            <a href="#disconnect"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>disconnect()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="169" class="link-to-prism">src/app/operation/parameters/domain-influence/domain-influence-edit.component.ts:169</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>






    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Component, OnInit, ViewChild } from &#x27;@angular/core&#x27;;
import { OperationParametersModel } from &#x27;../model/operation-parameters.model&#x27;;
import { DomainInfluenceFile } from &#x27;./model/domain-influence-file&#x27;;
import { MatSnackBar, MatSort } from &#x27;@angular/material&#x27;;
import { TranslateService } from &#x27;@ngx-translate/core&#x27;;
import { Operation } from &#x27;../../model/operation&#x27;;
import { DataSource } from &#x27;@angular/cdk/collections&#x27;;
import { Observable } from &#x27;rxjs/Observable&#x27;;
import { TdDialogService } from &#x27;@covalent/core&#x27;;
import { DomainInfluenceService } from &#x27;./services/domain-influence.service&#x27;;
import { DomainInfluenceImportResult } from &#x27;./model/domain-influence-import-result&#x27;;
import { FileService } from &#x27;../../../core/service/file-service/file-service&#x27;;
import { map } from &#x27;rxjs/operators&#x27;;
import { AuthorizationService } from &#x27;../../../core/service/http/authorization.service&#x27;;
import { ConfirmBeforeQuit } from &#x27;../../../core/confirm-before-quit&#x27;;
import { UploadInputComponent } from &#x27;../../../shared/upload-input/upload-input.component&#x27;;
import { Subscription } from &#x27;rxjs/Subscription&#x27;;
import { ReadOnlyService } from &#x27;../../service/read-only.service&#x27;;

@Component({
  templateUrl: &#x27;./domain-influence-edit.component.html&#x27;,
  styleUrls: [&#x27;../parameter-edit.scss&#x27;, &#x27;./domain-influence-edit.component.scss&#x27;]
})
export class DomainInfluenceEditComponent implements OnInit, ConfirmBeforeQuit {
  private _subscriptions: Subscription[] &#x3D; [];
  private _readOnly &#x3D; false;
  operation: Operation;
  file: DomainInfluenceFile;


  uploadResult: DomainInfluenceImportResult &#x3D; undefined;
  validationErrorCsvContent: string;

  fileDataSource: DomainInfluenceFileDataSource;

  @ViewChild(UploadInputComponent)
  uploadInputComponent: UploadInputComponent;


  isFormModified(): boolean {
    return this.uploadInputComponent &amp;&amp; this.uploadInputComponent.isFormModified();
  }


  get fileDisplayedColumns() {
    let readableColumn &#x3D; [&#x27;file&#x27;, &#x27;author&#x27;, &#x27;importedDate&#x27;];
    if (this.readOnly || !this.authorizationService.hasAtLeastOneRole([&quot;DELETE_DOI&quot;])) {
      return readableColumn;
    } else {
      return readableColumn.concat([&#x27;delete&#x27;]);
    }
  }

  @ViewChild(MatSort) sort: MatSort;

  constructor(private parametersModel: OperationParametersModel,
              private domainInfluenceService: DomainInfluenceService,
              private fileService: FileService,
              private dialogService: TdDialogService,
              private translateService: TranslateService,
              private authorizationService: AuthorizationService,
              private readOnlyService: ReadOnlyService,
              private snackBar: MatSnackBar) {
  }


  ngOnDestroy(): void {
    this._subscriptions.forEach(s &#x3D;&gt; s.unsubscribe());
  }

  get readOnly() {
    return this._readOnly;
  }

  ngOnInit() {
    this._subscriptions.push(
      this.readOnlyService.isDoiInReadOnly()
        .subscribe(
          readOnly &#x3D;&gt; {
            this._readOnly &#x3D; readOnly;
          }
        ),
      this.parametersModel.currentOperation.subscribe(operation &#x3D;&gt; this.operation &#x3D; operation),
      this.parametersModel.currentDomainInfluenceFile.subscribe(file &#x3D;&gt; this.file &#x3D; file),
    );
    this.fileDataSource &#x3D; new DomainInfluenceFileDataSource(this.parametersModel);

  }


  get uploadUrl(): string {
    return &#x60;${this.domainInfluenceService.serviceUrl}/${this.operation.id}/upload&#x60;;
  }


  resetUploadResult() {
    this.uploadResult &#x3D; undefined;
  }

  processUploadResult(result: DomainInfluenceImportResult) {
    this.uploadResult &#x3D; result;
    if (this.uploadResult) {
      if (this.uploadResult.validationErrors.length &gt; 0) {
        this.validationErrorCsvContent &#x3D; this.fileService.generateCsvFromFlatObject(
          this.uploadResult.validationErrors, &quot;global.validation.csv.header&quot;);
      } else {
        this.parametersModel.updateDomainInfluenceFile(result.domainOfInfluenceFile);
        // UI-feedback: notify user that import was successful
        this.snackBar.open(
          this.translateService.instant(
            &#x27;parameters.domain-influence.edit.form.import-success&#x27;,
            {fileName: result.domainOfInfluenceFile.fileName}
          ),
          &#x27;&#x27;,
          {
            duration: 5000
          }
        );
      }
    }
  }

  downloadValidationReport() {
    this.fileService.downloadFile(&#x27;domain_of_influence_errors.csv&#x27;, this.validationErrorCsvContent);
  }

  download(file: DomainInfluenceFile, event: Event) {
    this.domainInfluenceService.download(this.operation.id).subscribe(blob &#x3D;&gt; {
      this.fileService.downloadBlob(file.fileName, blob);
    });
    event.preventDefault();  // prevent href link
    event.stopPropagation(); // prevent repository panel&#x27;s expansion toggle
  }

  deleteFile() {
    this.dialogService.openConfirm({
      message: this.translateService.instant(&#x27;parameters.domain-influence.edit.delete-dialog.message&#x27;,
        {fileName: this.file.fileName}),
      disableClose: true,
      cancelButton: this.translateService.instant(&#x27;global.actions.no&#x27;),
      acceptButton: this.translateService.instant(&#x27;global.actions.yes&#x27;),
    }).afterClosed().subscribe((accept: boolean) &#x3D;&gt; {
      if (accept) {
        this.domainInfluenceService.deleteFile(this.file.id).subscribe(() &#x3D;&gt; {
          this.snackBar.open(
            this.translateService.instant(
              &#x27;parameters.domain-influence.edit.delete-success&#x27;,
              {fileName: this.file.fileName}
            ),
            &#x27;&#x27;,
            {duration: 5000}
          );
          this.parametersModel.updateDomainInfluenceFile(new DomainInfluenceFile());
        });
      }
    });
  }
}

class DomainInfluenceFileDataSource extends DataSource&lt;DomainInfluenceFile&gt; {
  constructor(private parametersModel: OperationParametersModel) {
    super();
  }

  connect(): Observable&lt;DomainInfluenceFile[]&gt; {
    return this.parametersModel.currentDomainInfluenceFile.pipe(map(file &#x3D;&gt; [file]));
  }

  disconnect() {
  }
}
</code></pre>
    </div>
</div>







                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'class';
            var COMPODOC_CURRENT_PAGE_URL = 'DomainInfluenceFileDataSource.html';
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
